//
//  ViewController.m
//  SpiltView
//
//  Created by xiaoyong.cxy on 15/11/4.
//  Copyright © 2015年 alibaba. All rights reserved.
//

#import "ViewController.h"

#define SIZECLASS_2_STR(sizeClass) [[self class] sizeClassInt2Str:sizeClass]


@interface ViewController () {
    NSString *_autoDes;
    NSString *_aodiDes;
    
    NSMutableDictionary    *_constraintsDict;
}

@end

@implementation ViewController

- (instancetype)initWithCoder:(NSCoder *)aDecoder
{
    self = [super initWithCoder:aDecoder];
    if (self) {
        _autoDes = @"长安铃木新奥拓是铃木继雨燕、超级维特纳、SX4、SPLASH之后的第五款全球战略车型，基于全新的生产平台作为低碳车型的旗舰进行研发，着力打造超低二氧化碳排放和燃油消耗，为关爱地球家园的人们度身设计，是目前（截止2009年8月）铃木平台上最小的世界战略车型。\r\n奥拓是铃木汽车的标志性经典产品，当第一代奥拓在下线后，它就凭借优良的产品特性迅速走红日本市场，并引发了日本社会购买小车数量激增的社会现象,在世界的范围内成为一款备受好评的小型车，受到全球超过400万名车主的青睐。\r\n历经30年的锤炼与进化，新奥拓作为铃木继雨燕、铃木超级维特拉、SX4、Splash之后的第五款全球战略车型闪耀登场，并逐步在欧洲、亚洲地区正式投产上市。在这款世界车型上，铃木赋予了新奥拓作为一款eco-friendly(环境友好)车型的设计理想，集活力时尚的欧洲风格造型、全球统一的精湛工艺以及以杰出的环保节能特性于一身，堪称引领世界小车品质标杆的创新力作。";
        
        _aodiDes = @"奥迪R8超级跑车拥有无比迷人的驾控感，在奥迪品牌的运动车型中堪称翘楚。中置420马力V8FSI发动机、全时四轮驱动系统和奥迪全铝车身空间框架结构，赋予了它无比出众的超凡动力表现。作为奥迪旗下的首款中置发动机运动车型，奥迪R8超级跑车将奥迪在无数场汽车运动赛事中取胜的经验、突破传统的设计以及领先科技完美地融合在一起，并使奥迪“突破科技，启迪未来”的品牌理念成为其在赛道和公路上出色表现的最佳注解。\r\n   奥迪在全世界的汽车运动赛场上获得了无数场胜利。继上世纪80年代奥迪摘得汽车拉力赛、房车赛桂冠后，长距离汽车耐力赛无疑成为迄今奥迪赛车工程师们面临的最大挑战。\r\n   奥迪同样成功地征服了这一挑战：奥迪R8赛车五次赢得享有极高声望的勒芒24小时耐力赛，具体时间为2000年到2002年，以及2004年和2005年。其中两次占据比赛的前三甲。\r\n  勒芒24小时耐力赛无疑是奥迪赛车部工程师们面临的最严峻的挑战，因为它所要求的工程学水平要远远超过仅仅将所有系统只保持短时间的超高性能。除了必要的顶级性能和优异的驱动力外，长距离汽车赛的关键在于持久力和可靠性，以及最适宜的人机工程学设计。";
        
        _constraintsDict = [NSMutableDictionary dictionary];
    }
    
    return self;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    
    self.view.backgroundColor = [UIColor yellowColor];
    
    // add Content View
    _imageIV = [[UIImageView alloc] init];
    _imageIV.backgroundColor = [UIColor whiteColor];
    _imageIV.contentMode = UIViewContentModeScaleAspectFit;
    [self.view addSubview:_imageIV];
    
    _textView = [[UITextView alloc] init];
    _textView.backgroundColor = [UIColor greenColor];
    _textView.textColor = [UIColor blackColor];
    _textView.font = [UIFont systemFontOfSize:24];
    [self.view addSubview:_textView];
    
    [self configConstraints];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    [self updateConstraintsForSizeClass:self.traitCollection.horizontalSizeClass];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark -
#pragma mark Constraints Related

- (void)configConstraints
{
    _imageIV.translatesAutoresizingMaskIntoConstraints = NO;
    _textView.translatesAutoresizingMaskIntoConstraints = NO;
    
    NSLayoutConstraint *c0 = [NSLayoutConstraint constraintWithItem:_imageIV attribute:NSLayoutAttributeWidth relatedBy:NSLayoutRelationEqual toItem:_imageIV attribute:NSLayoutAttributeHeight multiplier:1 constant:0];
    c0.priority = UILayoutPriorityDefaultHigh;
    [_imageIV addConstraint:c0];
    
    [self.view addConstraints:[self constraintsForSizeClass:self.traitCollection.horizontalSizeClass]];
    [self.view updateConstraints];
}

- (NSArray *)constraintsForSizeClass:(UIUserInterfaceSizeClass)sizeClass
{
    NSArray *constraints = nil;
    if (sizeClass == UIUserInterfaceSizeClassCompact) {
        constraints = _constraintsDict[@"Compact"];
        if (!constraints) {
            NSArray *c1 = [NSLayoutConstraint constraintsWithVisualFormat:@"H:|-10-[_imageIV]-10-|"
                                                                  options:0
                                                                  metrics:nil
                                                                    views:NSDictionaryOfVariableBindings(_imageIV)];
            
            NSArray *c2 = [NSLayoutConstraint constraintsWithVisualFormat:@"V:|-20-[_imageIV]-[_textView]-20-|"
                                                                  options:NSLayoutFormatAlignAllLeft | NSLayoutFormatAlignAllRight
                                                                  metrics:nil
                                                                    views:NSDictionaryOfVariableBindings(_imageIV, _textView)];
            NSMutableArray *arr = [NSMutableArray arrayWithArray:c1];
            [arr addObjectsFromArray:c2];
            [_constraintsDict setValue:arr forKey:@"Compact"];
            
            constraints = arr;
        }
    }
    else {
        
        constraints = _constraintsDict[@"Regular"];
        if (!constraints) {
            NSArray *c1 = [NSLayoutConstraint constraintsWithVisualFormat:@"H:|-10-[_imageIV]-20-[_textView]-10-|" options:NSLayoutFormatAlignAllCenterY metrics:nil views:NSDictionaryOfVariableBindings(_imageIV, _textView)];

            NSLayoutConstraint *c3 = [NSLayoutConstraint constraintWithItem:_imageIV attribute:NSLayoutAttributeWidth relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeWidth multiplier:0.5 constant:-20];
            NSLayoutConstraint *c6 = [NSLayoutConstraint constraintWithItem:_imageIV attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeWidth multiplier:0.5 constant:-20];
            NSLayoutConstraint *c4 = [NSLayoutConstraint constraintWithItem:_textView attribute:NSLayoutAttributeWidth relatedBy:NSLayoutRelationEqual toItem:_imageIV attribute:NSLayoutAttributeWidth multiplier:1 constant:0];
            NSLayoutConstraint *c5 = [NSLayoutConstraint constraintWithItem:_textView attribute:NSLayoutAttributeHeight relatedBy:NSLayoutRelationEqual toItem:self.view attribute:NSLayoutAttributeHeight multiplier:1 constant:0];
            
            NSMutableArray *arr = [NSMutableArray arrayWithObjects:c3, c4, c5, c6, nil];
            [arr addObjectsFromArray:c1];
            [_constraintsDict setValue:arr forKey:@"Regular"];
            constraints = arr;
        }
    }
    
    return constraints;
}

- (void)updateConstraintsForSizeClass:(UIUserInterfaceSizeClass)newSizeClass
{
    NSArray *currentConstraints = [self constraintsForSizeClass:self.traitCollection.horizontalSizeClass];
    NSArray *newConstraints = [self constraintsForSizeClass:newSizeClass];
    [self.view removeConstraints:currentConstraints];
    [self.view addConstraints:newConstraints];
    
    if (newSizeClass == UIUserInterfaceSizeClassRegular) {
        _imageIV.image = [UIImage imageNamed:@"aodi.jpg"];
        _textView.font = [UIFont systemFontOfSize:24];
        _textView.text = _aodiDes;
    }
    else {
        _imageIV.image = [UIImage imageNamed:@"aotuo.jpg"];
        _textView.font = [UIFont systemFontOfSize:16];
        _textView.text = _aodiDes;
    }
    
    [self.view updateConstraintsIfNeeded];
}

#pragma mark -
#pragma mark Size Class Related

- (void)traitCollectionDidChange:(UITraitCollection *)previousTraitCollection
{
    [super traitCollectionDidChange:previousTraitCollection];
    
    NSLog(@"traitCollectionDidChange: previous %@, new %@", SIZECLASS_2_STR(previousTraitCollection.horizontalSizeClass), SIZECLASS_2_STR(self.traitCollection.horizontalSizeClass));
}

- (void)willTransitionToTraitCollection:(UITraitCollection *)newCollection withTransitionCoordinator:(id<UIViewControllerTransitionCoordinator>)coordinator
{
    [super willTransitionToTraitCollection:newCollection withTransitionCoordinator:coordinator];
    
    NSLog(@"willTransitionToTraitCollection: current %@, new: %@", SIZECLASS_2_STR(self.traitCollection.horizontalSizeClass), SIZECLASS_2_STR(newCollection.horizontalSizeClass));
    [self updateConstraintsForSizeClass:newCollection.horizontalSizeClass];
    
}

- (void)viewWillTransitionToSize:(CGSize)size withTransitionCoordinator:(id<UIViewControllerTransitionCoordinator>)coordinator
{
    [super viewWillTransitionToSize:size withTransitionCoordinator:coordinator];
    
    NSLog(@"viewWillTransitionToSize: size %@", NSStringFromCGSize(size));
}

#pragma mark - 
#pragma mark Helper Method

+ (NSString*)sizeClassInt2Str:(UIUserInterfaceSizeClass)sizeClass
{
    switch (sizeClass) {
        case UIUserInterfaceSizeClassCompact:
            return @"UIUserInterfaceSizeClassCompact";
        case UIUserInterfaceSizeClassRegular:
            return @"UIUserInterfaceSizeClassRegular";
        case UIUserInterfaceSizeClassUnspecified:
        default:
            return @"UIUserInterfaceSizeClassUnspecified";
    }
}


@end
